#!/bin/sh

# This isn't ready yet.

function download()
{
  FILENAME=`echo "$URL" | sed 's .*/  '`

  for i in "$URL" http://www.landley.net/code/firmware/mirror/"$FILENAME" ""
  do
    # Return success if we have a valid copy of the file

    SUM=`cat "$SRCDIR/$FILENAME" | sha1sum | awk '{print $1}'`
    if [ x"$SUM" == x"$SHA1" ]
    then
      touch "$SRCDIR/$FILENAME"
      echo "Confirmed $FILENAME"
      return 0
    fi

    # If there's a corrupted file, delete it.  In theory it would be nice
    # to resume downloads, but wget creates "*.1" files instead.

    rm "$SRCDIR/$FILENAME" 2> /dev/null

    # If we have another source, try to download file.

    if [ -n "$i" ]
    then
      wget -P "$SRCDIR" "$i"
    fi
  done

  # Return failure.

  echo "Could not download $FILENAME"
  return 1
}

# Lots and lots of source code.  Download everything we haven't already got
# a copy of.

echo "=== Download source code." &&

export SRCDIR=sources/packages

# Base operating system

URL=http://www.kernel.org/pub/linux/kernel/v2.6/linux-2.6.14.tar.bz2 \
SHA1=e8024d1c65b5fd14be0d64904ff9bb904a290526 \
download &&

URL=http://www.kernel.org/pub/linux/kernel/v2.6/testing/patch-2.6.15-rc2.bz2 \
SHA1=6e464cf384ebae7c7155f7c9aa6cd286ab0f343f \
download &&

#URL=http://user-mode-linux.sourceforge.net/work/current/2.6/2.6.15-rc1/patches.tar \
#SHA1=97a7bf51993854a659a231d8f29b0e017f94c610 \
#download &&

URL=http://www.uclibc.org/downloads/uClibc-0.9.28.tar.bz2 \
SHA1=9124a6e5b0454da3f967725d54fde806189ad27b \
download &&

URL=http://www.busybox.net/downloads/snapshots/busybox-20051110.tar.bz2 \
SHA1=ee7a26954c5c7bcad146d8d862e81891775f9b98 \
download &&

URL=http://unc.dl.sourceforge.net/sourceforge/squashfs/squashfs2.2-r2.tar.gz \
SHA1=5589f65bb34014930d7cdbbf6dfbc2cb8f492470 \
download &&

# Build tools

URL=http://ep09.pld-linux.org/~mmazur/linux-libc-headers/linux-libc-headers-2.6.12.0.tar.bz2 \
SHA1=e72c9b260995b269c9fb9248ed468c18fb01f3fd \
download &&

URL=ftp://ftp.gnu.org/gnu/binutils/binutils-2.16.1.tar.bz2 \
SHA1=5c80fd5657da47efc16a63fdd93ef7395319fbbf \
download &&

URL=ftp://ftp.gnu.org/gnu/gcc/gcc-4.0.2/gcc-core-4.0.2.tar.bz2 \
SHA1=218409fa352de14c2a77860f23d99d7f51d20f43 \
download &&

URL=ftp://ftp.gnu.org/gnu/m4/m4-1.4.3.tar.bz2 \
SHA1=51a4d360e5c22b7c0a849759079905b5a1fdcaa4 \
download &&

URL=ftp://ftp.gnu.org/gnu/bison/bison-2.1.tar.bz2 \
SHA1=0a3a5b3a506e4c406e6a82640058d3a29a309b84 \
download &&

URL=ftp://ftp.gnu.org/non-gnu/flex/flex-2.5.4a.tar.gz \
SHA1=38a5e15c348d2ca7dce94d71de2b51484d23e2ef \
download &&

#URL=ftp://ftp.gnu.org/gnu/autoconf/autoconf-2.59.tar.bz2 \
#SHA1=d366a07b2d99c95b7f24395aa8a8e023d8b93b69 \
#download &&

URL=ftp://ftp.gnu.org/gnu/make/make-3.80.tar.bz2 \
SHA1=d2085842f08e57d58d3e1cd75a5f0342a60e5f45 \
download &&

# Boot loader

URL=http://www.cix.co.uk/~mayday/dev86/bin86-0.16.17.tar.gz \
SHA1=656f06b4b26d08412132e338baa25e42d713eeec \
download &&

URL=http://www.cix.co.uk/~mayday/dev86/as86-0.16.17.tar.gz \
SHA1=bfced28a54a0c7994ea4ae94bcabf0e36f99b898 \
download &&

URL=http://home.san.rr.com/johninsd/pub/linux/lilo/lilo-22.7.1.src.tar.gz \
SHA1=b431bb0756e1f42c38fc4645063acaea7f2ddcc7 \
download &&

# Application libraries

URL=http://www.zlib.net/zlib-1.2.3.tar.bz2 \
SHA1=967e280f284d02284b0cd8872a8e2e04bfdc7283 &&
download &&

# Applications

URL=http://matt.ucc.asn.au/dropbear/dropbear-0.46.tar.bz2 \
SHA1=2b6d2083ec0294fde55c75e4080c06637cbcf833 \
download &&

#URL=http://unc.dl.sourceforge.net/sourceforge/strace/strace-4.5.12.tar.bz2 \
#SHA1= \
#download &&

# Temporary crutches (need to fix busybox to no longer need these).

URL=ftp://ftp.gnu.org/gnu/diffutils/diffutils-2.8.1.tar.gz \
SHA1=a4c467c3a6a08cde9f3d94d02067ec26436e7dc5 \
download &&

URL=ftp://ftp.gnu.org/gnu/bash/bash-2.05b.tar.gz \
SHA1=b3e158877f94e66ec1c8ef604e994851ee388b09 \
download &&

echo === Got all source.
