#!/bin/sh

export LC_ALL=POSIX
unset CFLAGS CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
DIR=`pwd`

. "$DIR"/sources/scripts/runuml.sh

echo -e "\e[32m=== Phase 2: Build the final system." &&

if [ ! -f tools/build.sqf ]
then
  if [ `id -u` -eq 0 ]
  then

    # A bit of paranoia
    umount tmpdir/build/{tools,sources,proc,sys,dev/pts,dev} 2> /dev/null
    rm -rf tmpdir/build 2> /dev/null

    mkdir -p tmpdir/build/{tools,sources} &&
    mount --bind -o,ro tmpdir/tools tmpdir/build/tools &&
    mount --bind -o,ro sources tmpdir/build/sources &&
    chroot tmpdir/build /sources/scripts/2.2-firmware-build.sh &&
    umount tmpdir/build/{tools,sources}

    if [ -f tmpdir/build/build_complete ]
    then
      rm -f tmpdir/build.sqf 2> /dev/null
      rmdir tmpdir/build/{tools,sources} &&
      rm tmpdir/build/build_complete &&
      mv tmpdir/build/tmp/initramfs-busybox tmpdir &&
      tmpdir/mksquashfs tmpdir/build tmpdir/build.sqf -info
    fi

  else
    sources/scripts/2.0-reset-tmpdir.sh &&
    export UMLSETUP=sources/scripts/2.1-firmware-umlsetup.sh &&
    runuml sources/scripts/2.2-firmware-build.sh
  fi
fi

if [ -f tmpdir/build.sqf ]
then
  sources/scripts/2.3-firmware-package.sh
fi

if [ ! -f build.sqf ]; then exit 1; fi
