#!/bin/sh

# Script run from the second invocation of UML.  Set up UML environment with
# /tools mounted from tools.img, and /tools/sources bind mounted under that.

export PATH=/sbin:/usr/sbin:/bin:/usr/bin
cd "$DIR"/tmpdir &&

# Mount workspace, and /tools and /sources in that.
mkdir mnt # No && because the directory may already be there, so this can fail.
mke2fs -F workspace.img &&
mount -n -o loop -t ext2 workspace.img mnt &&
rmdir mnt/lost+found 2>/dev/null

mkdir mnt/{tools,sources} &&
mount -n -o loop -t squashfs tools.img mnt/tools &&
mount -n --bind -o ro ../sources mnt/sources &&

# Enable swap
mkdir mnt/sys &&
mount -t sysfs mnt/sys mnt/sys &&
mknod -m 700 mnt/ubda b `sed 's/:.*//' mnt/sys/block/ubda/dev` \
        `sed 's/.*://' mnt/sys/block/ubda/dev` &&
swapon mnt/ubda &&
rm mnt/ubda &&
umount mnt/sys &&
rmdir mnt/sys &&

if [ $? -ne 0 ]; then exit 1; fi

# Run the next stage build script

chroot mnt sources/scripts/2.2-firmware-build.sh

# Did the build complete?

if [ -f mnt/build_complete ]
then
  rm -f build.sqf 2> /dev/null
  rm -f mnt/build_complete &&
  umount mnt/tools mnt/sources &&
  mv mnt/tmp/initramfs-busybox . &&
  ./mksquashfs mnt build.sqf -info
fi
